unit UfrmMain;

interface

uses
	Windows,
	Classes,
	Graphics,
	Forms,
	Controls,
	Menus,
	Dialogs,
	StdCtrls,
	Buttons,
	ExtCtrls,
	ComCtrls,
	HintStatusBar;

type
	TfrmMain = class(TForm)
    SpeedPanel: TPanel;
    Panel1: TPanel;
    btnExit: TSpeedButton;
    StatusBar: THintStatusBar;
    btnStartDemo: TSpeedButton;
    timDemo: TTimer;
    timProgress: TTimer;
		memDescriptions: TMemo;
    btnException: TSpeedButton;
    btnResize: TSpeedButton;
		procedure FormCreate(Sender: TObject);
		procedure FileExit(Sender: TObject);
		procedure ShowHint(Sender: TObject);
		procedure timDemoTimer(Sender: TObject);
		procedure StartStopDemo(Sender: TObject);
		procedure timProgressTimer(Sender: TObject);
		procedure StatusBarClick(Sender: TObject);
		procedure btnExceptionClick(Sender: TObject);
	private
		FDemoTime: Integer;

		procedure SetDemoTime(Value : Integer);
	public
		{ Public declarations }
		property DemoTime: Integer
			read		FDemoTime
			write		SetDemoTime;
	end;

var
  frmMain: TfrmMain;

implementation

uses
	SysUtils;

{$R *.DFM}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
	Application.OnHint := ShowHint;
	Application.HintHidePause	:= 5000;

	DemoTime	:= -1;
	btnStartDemo.Hint	:= StatusBar.VersionInfo;
end;

procedure TfrmMain.FileExit(Sender: TObject);
begin
	Close;
end;

procedure TfrmMain.ShowHint(Sender: TObject);
begin
	if StatusBar.SimplePanel then begin
		StatusBar.SimpleText := Application.Hint;
		end
	else begin
		StatusBar.PanelByName('Hints').Text	:= Application.Hint;
	end;
end;

procedure TfrmMain.timDemoTimer(Sender: TObject);
begin
	DemoTime	:= DemoTime + 1;
end;

procedure TfrmMain.SetDemoTime(Value : Integer);
var
	m	: String;
	lf	: String;
begin
	if Value <> FDemoTime then begin
		FDemoTime	:= Value;
	end;
	case FDemoTime of
		-1		: begin
				lf	:= char(13) + char(10);
				m	:= 'THintStatusBar !';
				m	:= m + lf + 'A full replacement of TStatusbar!';
				m	:= m + lf;
				m	:= m + lf + 'Benefits :';
				m	:= m + lf + 'Userdefined floating panel. (Resize the window; here the ';
				m	:= m + lf + '  first panel will be resized).';
				m	:= m + lf + 'Multiline hints. (see first panel).';
				m	:= m + lf + 'You can simply show a ProgressBar.';
				m	:= m + lf + 'Panels are named for easier addressing.';
				m	:= m + lf + 'Panel editor shows your Statusbar as is.';
				m	:= m + lf + 'Panels can be saved to file or restored from file.';
				m	:= m + lf + 'Every Panel has its own OnClick event.';
				m	:= m + lf + 'Every Panel has its own Hint property, which appears under each panel.';
				m	:= m + lf + 'Every Panel has its own Font property. (version 1.05)';
				m	:= m + lf + 'Context menu invokes the Panel editor. (version 1.05)';
				m	:= m + lf ;
				m	:= m + lf + 'SourceCode : $10, 15 DM, call SWREG 12864';
				m	:= m + lf ;
				m	:= m + lf + 'Author :';
				m	:= m + lf + 'Chris Ueberall';
				m	:= m + lf + '100567.1527@compuserve.com';

				memDescriptions.Text	:= m;
			end;
		0		: begin
				memDescriptions.Text	:= 'in 10 seconds you will see the ProgressBar in action!';
			end;
		10	: begin
				Statusbar.ProgressBarPanelIndex	:= Statusbar.Panels.IndexOf('ProgressBar');
				Statusbar.ProgressBarVisible	:= True;
				timProgress.Enabled	:= True;
				memDescriptions.Text	:= 'in 10 seconds you will see the ProgressBar on the first Panel !';
			end;
		20	: begin
				Statusbar.ProgressBarPanelIndex	:= 0;
				memDescriptions.Text	:= 'in 10 seconds ProgressBar will stop !';
			end;
		30	: begin
				timProgress.Enabled	:= False;
				Statusbar.ProgressBarVisible	:= False;
				Statusbar.ProgressBarPanelIndex	:= 1;
				memDescriptions.Text	:= 'in 10 seconds Demo will stop !';
			end;
		39	: begin
				memDescriptions.Text	:= 'End of the Demo !';
			end;
		40	: begin
				StartStopDemo(Self);
			end;
	end;
	StatusBar.PanelByName('Timer').Text 	:= IntToStr(DemoTime);
end;

procedure TfrmMain.StartStopDemo(Sender: TObject);
begin
	if not timDemo.Enabled then begin
		DemoTime	:= -1;
		timDemo.Enabled	:= True;
		btnStartDemo.Caption	:= 'Stop Demo';
		end
	else begin
		Statusbar.ProgressBarVisible	:= False;
		Statusbar.ProgressBarPanelIndex	:= 1;
		timDemo.Enabled			:= False;
		timProgress.Enabled	:= False;
		DemoTime	:= -1;
		btnStartDemo.Caption	:= 'Start Demo';
	end;
end;

procedure TfrmMain.timProgressTimer(Sender: TObject);
begin
	StatusBar.ProgressBarPosition	:= (StatusBar.ProgressBarPosition + 1) mod 100;
end;

procedure TfrmMain.StatusBarClick(Sender: TObject);
begin
	ShowMessage('This Panel has no OnClick event, so the Statusbar OnClick event raises !');
end;

procedure TfrmMain.btnExceptionClick(Sender: TObject);
begin
	try
		StatusBar.PanelByName('NotExistingPanel').Text	:= 'Exception';
	except
		on E:Exception do begin
			if E.ClassName = 'EPanelNotFoundError' then begin
				ShowMessage('Panel not found !');
				end
			else begin
				ShowMessage(E.Message);
			end;
		end;
	end;
end;

end.

